<script>
    import { goto } from '$app/navigation';
    
    let raw = history.state;
    /**
	 * @type {any[]}
	 */
    let personnes = [];
    /**
	 * @type {any[]}
	 */
    let lots = [];

    for (let i = 0; i < raw["personnes"].length; i++) {
        let amount = raw["personnes"][i]["Tarif"].split(" ")[0];
        for (let j = 0; j < amount; j++) {
            personnes.push({
                "nom": raw["personnes"][i]["Nom"].toUpperCase(),
                "prenom": raw["personnes"][i]["Prénom"][0].toUpperCase() + raw["personnes"][i]["Prénom"].slice(1).toLowerCase(),
                "email": raw["personnes"][i]["Email"],
                "montant": amount
            });
        }
    }

    var alph = "abcdef"
    for (let i = 0; i < raw["lots"].length; i++) {
        let amount = raw["lots"][i]["Nombre"];
        for (let j = 0; j < amount; j++) {
            lots.push({
                "id": i,
                "lot": raw["lots"][i]["N° lot"],
                "nom": raw["lots"][i]["Intitulé"],
                "content": raw["lots"][i]["Contenu"],
                "comment": raw["lots"][i]["Commentaire"],
                "photo": "lot_"+(i+1)+".png",
                "montant": amount
            });
        }
    }

    // Order lots by price
    lots.sort((a, b) => {
        return a.price - b.price;
    });

    // Randomize 5 lot by 5 lot
    for (let i = 0; i < lots.length; i += 5) {
        let j = i + 5;
        if (j > lots.length) {
            j = lots.length;
        }
        let sub = lots.slice(i, j);
        sub.sort(() => {
            return Math.random() - 0.5;
        });
        lots.splice(i, j - i, ...sub);
    }

    // Do the raffle
    /**
	 * @type {any[]}
	 */
    let raffles = [];

    for (let i = 0; i < lots.length; i++) {
        let lot = lots[i];
        let person = personnes[Math.floor(Math.random() * personnes.length)];
        raffles.push({
            "lot": lot,
            "person": person
        });
        personnes.splice(personnes.indexOf(person), 1);
    }

    // Fake loading
    let csl = "";

    /**
	 * @param {number | undefined} ms
	 */
    async function sleep(ms) {
        return new Promise(resolve => setTimeout(resolve, ms));
    }

    let dlAnchorElem;
    async function fakeLoading() {
        // Download json file
        await sleep(1000);
        csl += "J'ai reçu les données : \n";
        csl += "  Personnes : " + personnes.length + "\n";
        csl += "  Lots : " + lots.length + "\n";
        await sleep(3000);
        csl += "Je mélange les lots...\n";
        await sleep(3000);
        csl += "Je mélange les personnes...\n";
        await sleep(3000);
        csl += "Je fais le tirage...\n";
        await sleep(3000);
        csl += "J'ai fini !\n";
        csl += "Téléchargement du fichier de sortie (en cas de crash)\n";

        // Download the file
        let dataStr = "data:text/json;charset=utf-8," + encodeURIComponent(JSON.stringify({lots:lots, personnes:personnes, raffle:raffles}));
        let dlAnchorElem = document.getElementById('downloadAnchorElem');
        dlAnchorElem.setAttribute("href", dataStr);
        dlAnchorElem.setAttribute("download", "tirage.json");
        dlAnchorElem.click();

        await sleep(3000);

        csl += "Téléchargement terminé !\n";
        csl += "Redirection vers la page d'animations...\n";

        await sleep(3000);

        goto("/animations", { state: {lots:lots, personnes:personnes, raffle:raffles} });
    }

    fakeLoading();
    
</script>

<body class="container">
	<nav>
		<ul>
			<li><h1>TN'Event Tirage</h1></li>
		</ul>
	</nav>
	<main class="container">
        <!-- Loading -->
        <button aria-busy="true">Tirage en cours...</button>
        <article>
            <!-- Console output -->
            <h2>Console</h2>
            <pre>{csl}</pre>
        </article>
        <a id="downloadAnchorElem" style="display:none;" >aa</a>
	</main>
</body>
